import pygame
import random
import time

pygame.init()

game_font = pygame.font.Font('data/font/font.ttf', 35)

screen = pygame.display.set_mode((700, 700))
cat_cords_X = 300
cat_cords_Y = 550
hat_cords_X = random.randint(2, (680 - 120))
hat_cords_Y = 5
snow_coords_Y = -700
snow_coords_X = 0

cat = pygame.image.load("cat.png")
hat = pygame.image.load("hat.png")
background = pygame.image.load("background.png")
snow = pygame.image.load("snow.png")
zacatek_bg = pygame.image.load("uvod.png")


def check_colision (mask1, mask2,mask1_coords,mask2_coords):
    x_off = mask2_coords[0] - mask1_coords[0]
    y_off = mask2_coords[1] - mask1_coords[1]
    if mask1.overlap(mask2, (x_off, y_off)):
        return True
    else:
        return False

def falling_snow(x, y):
    global snow_coords_Y
    screen.blit(snow, (x, y))
    snow_coords_Y += 5

cat_mask = pygame.mask.from_surface(cat)
hat_mask = pygame.mask.from_surface(hat)

running = True
blitni = False
prvni = True

while running:
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            running = False
        keys = pygame.key.get_pressed()
        if keys [pygame.K_SPACE]:
            stiskuto = True

    if prvni:
        background = pygame.image.load("uvod.png")
        screen.blit(background, (0, 0))

    screen.blit(background, (0, 0))
    screen.blit(cat,(cat_cords_X, cat_cords_Y))
    screen.blit(snow, (snow_coords_X, snow_coords_Y))
    if not blitni:
        screen.blit(hat,(hat_cords_X, hat_cords_Y))
        
    for event in pygame.event.get():
        if not blitni:
            keys = pygame.key.get_pressed()
            if keys [pygame.K_a] or keys [pygame.K_LEFT]:
                if cat_cords_X > 10:
                    cat_cords_X -= 10
            if keys [pygame.K_d] or keys [pygame.K_RIGHT]:
                if cat_cords_X < (690 - 150):
                    cat_cords_X += 10
            

    if check_colision(cat_mask, hat_mask, (cat_cords_X, cat_cords_Y), (hat_cords_X, hat_cords_Y)):
        cat = pygame.image.load("cat+hat.png")
        background = pygame.image.load("victory.png")
        falling_snow(snow_coords_X, snow_coords_Y)
        blitni = True

        

    elif hat_cords_Y < 650:
        hat_cords_Y += 5

    elif hat_cords_Y > 600:
        background = pygame.image.load("game_over.png")
        blitni = True

    if prvni:
        time.sleep(2)
    
    pygame.display.update()
    prvni = False
    time.sleep(0.008)
